/******************************************************************************
As this blog author is extremely unfamiliar with web development in general and
specifically CSS quirks, all styles are heavily commented so that rationale
behind adding them won't turn into magic over time.
******************************************************************************/

/* LAYOUT */

* {
    /* Makes block size calculation include padding and margins */
    box-sizing: border-box;
}

body {
    /* Chosen at random for now */
    max-width: 50em;
    /* Top margin is 3em of nav height + 1 em of actual margin */
    margin-top: 4em;
    /* 'auto' on left+right margins makes block centered */
    margin-left: auto;
    margin-right: auto;
}

nav.layout {
    /* makes size + position of the menu to be exactly on top of content box but
       it remains on top of the viewport when the page gets scrolled down */
    position: fixed;
    left: inherit;
    top: 0;
    max-width: inherit;
    width: 100%;
    /* assume 1em of the menu item text and 1em of free space from bottom and top */
    height: 3em;
    /* draw the menu on top of rest of the page */
    z-index: 1;
}

nav.layout ul {
    /* as menu is split into two categories, each must take at most 'body width / 2' */
    max-width: 512;
    position: absolute;
    padding: 0;
}

nav.layout ul li {
    /* menu items displayed on same line */
    display: inline;
}

nav.layout ul#info_menu {
    /* Navigation / informational items are aligned left */
    left: 0;
    padding-left: 1em;
}

nav.layout ul#tech_menu {
    /* Tech support stuff is aligned right */
    right: 0;
    padding-right: 1em;
}

section.layout {
    /* force articles to take all parent (body) width */
    width: 100%;
}

/* STYLE */

nav.layout {
    background-color: lightgray;
    border-bottom: 1px solid gray;
    border-bottom-left-radius: 1em;
    border-bottom-right-radius: 1em;
}

nav.layout li a {
    text-decoration: none;
    color: black;
    padding: 0 0.5em 0 0.5em;
}

nav.layout li a:hover {
    color: gray;
}

body {
    font-family: sans-serif;
    font-size: 1.1em;
    line-height: 1.4em;
}

article {
    margin: 1em;
}

a.more_ref {
    color: gray;
    text-decoration: none;
}

h1, h2, h3 {
    line-height: 1.2;
}

h1 a, h2 a, h3 a {
    color: black;
    text-decoration: none;
}

/* CODE SNIPPET HIGHLIGHTING */

pre, code { 
    /* Fix automatic browser font size reduction */
    font-family: monospace, monospace;
    font-size: 1em;
    /* Distinctive background */
    background-color: #eeeeee;
}

div.sourceCode {
    background-color: #eeeeee;
    overflow-x: auto;
    padding-left: 2em;
    border-left: 4px black double;
}

table.sourceCode, tr.sourceCode, td.lineNumbers, td.sourceCode {
  margin: 0;
  padding: 0;
  vertical-align: baseline;
  border: none;
}

table.sourceCode {
    width: 100%;
    line-height: 100%;
}

td.lineNumbers {
    text-align: right;
    padding-right: 4px;
    padding-left: 4px;
    color: #aaaaaa;
    border-right: 1px solid #aaaaaa;
}

td.sourceCode {
    padding-left: 5px;
}

span.kw { color: #0000ff; } /* Keyword */
span.dt { color: #000099; } /* Datatype */
span.ch { color: #008080; } /* Char */
span.st { color: #008000; } /* String */
span.co { color: #008000; } /* Comment */
span.ot { color: #ff4000; } /* Other */
span.al { color: #ff0000; } /* Alert */
span.er { color: #ff0000; font-weight: bold; } /* Error */
span.wa { color: #008000; font-weight: bold; } /* Warning */
span.sc { color: #008080; } /* SpecialChar */
span.vs { color: #008080; } /* VerbatimString */
span.ss { color: #008080; } /* SpecialString */
span.cf { color: #0000ff; } /* ControlFlow */
span.pp { color: #5365a1; } /* Preprocessor */
span.do { color: #008000; } /* Documentation */
span.an { color: #008000; } /* Annotation */
span.cv { color: #008000; } /* CommentVar */
span.in { color: #008000; } /* Informat